#!/bin/bash
psql <<EOF
-- Change your conf here
CREATE EXTENSION pg_rusage;
SET wal_compression = off;
SELECT pg_backend_pid();
DROP TABLE IF EXISTS aa, results;
-- DROP TABLE IF EXISTS aa_text, results;
CREATE TABLE aa (a int);
-- CREATE TABLE aa_text(a int, b text);
CREATE TABLE results (phase text, position pg_lsn);
CREATE EXTENSION IF NOT EXISTS pg_prewarm;
ALTER TABLE aa SET (FILLFACTOR = 50);
-- ALTER TABLE aa_text SET (FILLFACTOR = 50);
INSERT INTO results VALUES ('pre-insert', pg_current_wal_lsn());
INSERT INTO aa VALUES (generate_series(1,7000000)); -- 484MB
SELECT pg_size_pretty(pg_relation_size('aa'::regclass));
SELECT pg_prewarm('aa'::regclass);
-- 425~430MB
--INSERT INTO aa_text SELECT t.a, (random() * 10000000000)::int8
--  FROM generate_series(1,5000000) as t(a);
--SELECT pg_size_pretty(pg_relation_size('aa_text'::regclass));
--SELECT pg_prewarm('aa_text'::regclass);
CHECKPOINT;
INSERT INTO results VALUES ('pre-update', pg_current_wal_lsn());
-- here is where the FPIs are generated.
SELECT pg_rusage_reset();
UPDATE aa SET a = 7000000 + a;
--UPDATE aa_text SET a = 7000000 + a;
SELECT pg_rusage_print();
CHECKPOINT;
INSERT INTO results VALUES ('post-update', pg_current_wal_lsn());
SELECT * FROM results;
EOF
